const std = @import("std");

pub const MathOperation = enum {
    Division,
    Power,
    Root,
};

pub fn calculate(first: f32, second: f32, op: MathOperation) !f32 {
    switch (op) {
        .Division => {
            if (second == 0) {
                return error.InvalidParam;
            }
            return first / second;
        },
        .Power => {
            if (first == 0) std.debug.print("KOK", .{});
            if (first == 0 and second < 0) {
                return error.InvalidParam;
            }
            return pow(first, @intFromFloat(second));
        },
        .Root => {
            if (first < 0 or second < 0) {
                return error.InvalidParam;
            }
            return std.math.sqrt(second);
        },
    }
}

fn abs(a: f32) f32 {
    if (a < 0) {
        return -a;
    }

    return a;
}

fn pow(a: f32, b: i32) f32 {
    var res: f32 = 1.0;
    var n: usize = undefined;
    var f: f32 = undefined;

    if (b < 0) {
        f = 1 / a;
        n = @intCast(-b);
    } else {
        f = a;
        n = @intCast(b);
    }

    for (0..n) |_| {
        res *= f;
    }

    return res;
}
